diff --git a/gcc/analyzer/constraint-manager.cc b/gcc/analyzer/constraint-manager.cc
index 786bd6ccf85..2f7a6537493 100644
--- a/gcc/analyzer/constraint-manager.cc
+++ b/gcc/analyzer/constraint-manager.cc
@@ -1051,43 +1259,241 @@ constraint_manager::eval_condition (equiv_class_id lhs_ec,
   return tristate (tristate::TS_UNKNOWN);
 }
 
-/* Evaluate the condition LHS OP RHS, creating equiv_class instances for
-   LHS and RHS if they aren't already in equiv_classes.  */
+range
+constraint_manager::get_ec_bounds (equiv_class_id ec_id) const
+{
+  range result;
+
+  int i;
+  constraint *c;
+  FOR_EACH_VEC_ELT (m_constraints, i, c)
+    {
+      if (c->m_lhs == ec_id)
+	{
+	  if (tree other_cst = c->m_rhs.get_obj (*this).get_any_constant ())
+	    switch (c->m_op)
+	      {
+	      default:
+		gcc_unreachable ();
+	      case CONSTRAINT_NE:
+		continue;
+
+	      case CONSTRAINT_LT:
+		/* We have "EC_ID < OTHER_CST".  */
+		result.m_upper_bound = bound (other_cst, false);
+		break;
+
+	      case CONSTRAINT_LE:
+		/* We have "EC_ID <= OTHER_CST".  */
+		result.m_upper_bound = bound (other_cst, true);
+		break;
+	      }
+	}
+      if (c->m_rhs == ec_id)
+	{
+	  if (tree other_cst = c->m_lhs.get_obj (*this).get_any_constant ())
+	    switch (c->m_op)
+	      {
+	      default:
+		gcc_unreachable ();
+	      case CONSTRAINT_NE:
+		continue;
+
+	      case CONSTRAINT_LT:
+		/* We have "OTHER_CST < EC_ID"
+		   i.e. "EC_ID > OTHER_CST".  */
+		result.m_lower_bound = bound (other_cst, false);
+		break;
+
+	      case CONSTRAINT_LE:
+		/* We have "OTHER_CST <= EC_ID"
+		   i.e. "EC_ID >= OTHER_CST".  */
+		result.m_lower_bound = bound (other_cst, true);
+		break;
+	      }
+	}
+    }
+
+  return result;
+}
+
+/* Evaluate the condition LHS_EC OP RHS_CONST, avoiding the creation
+   of equiv_class instances.  */
 
 tristate
-constraint_manager::eval_condition (svalue_id lhs,
+constraint_manager::eval_condition (equiv_class_id lhs_ec,
 				    enum tree_code op,
-				    svalue_id rhs)
+				    tree rhs_const) const
 {
-  return eval_condition (get_or_add_equiv_class (lhs),
-			 op,
-			 get_or_add_equiv_class (rhs));
+  gcc_assert (!lhs_ec.null_p ());
+  gcc_assert (CONSTANT_CLASS_P (rhs_const));
+
+  if (tree lhs_const = lhs_ec.get_obj (*this).get_any_constant ())
+    return compare_constants (lhs_const, op, rhs_const);
+
+  /* Check for known inequalities of the form
+       (LHS_EC != OTHER_CST) or (OTHER_CST != LHS_EC).
+     If RHS_CONST == OTHER_CST, then we also know that LHS_EC != OTHER_CST.
+     For example, we might have the constraint
+       ptr != (void *)0
+     so we want the condition
+       ptr == (foo *)0
+     to be false.  */
+  int i;
+  constraint *c;
+  FOR_EACH_VEC_ELT (m_constraints, i, c)
+    {
+      if (c->m_op == CONSTRAINT_NE)
+	{
+	  if (c->m_lhs == lhs_ec)
+	    {
+	      if (tree other_cst = c->m_rhs.get_obj (*this).get_any_constant ())
+		if (compare_constants
+		      (rhs_const, EQ_EXPR, other_cst).is_true ())
+		  {
+		    switch (op)
+		      {
+		      case EQ_EXPR:
+			return tristate (tristate::TS_FALSE);
+		      case NE_EXPR:
+			return tristate (tristate::TS_TRUE);
+		      default:
+			break;
+		      }
+		  }
+	    }
+	  if (c->m_rhs == lhs_ec)
+	    {
+	      if (tree other_cst = c->m_lhs.get_obj (*this).get_any_constant ())
+		if (compare_constants
+		      (rhs_const, EQ_EXPR, other_cst).is_true ())
+		  {
+		    switch (op)
+		      {
+		      case EQ_EXPR:
+			return tristate (tristate::TS_FALSE);
+		      case NE_EXPR:
+			return tristate (tristate::TS_TRUE);
+		      default:
+			break;
+		      }
+		  }
+	    }
+	}
+    }
+  /* Look at existing bounds on LHS_EC.  */
+  range lhs_bounds = get_ec_bounds (lhs_ec);
+  return lhs_bounds.eval_condition (op, rhs_const);
 }
 
-/* Delete any information about svalue_id instances identified by P.
+/* Evaluate the condition LHS OP RHS, without modifying this
+   constraint_manager (avoiding the creation of equiv_class instances).  */
+
+tristate
+constraint_manager::eval_condition (const svalue *lhs,
+				    enum tree_code op,
+				    const svalue *rhs) const
+{
+  lhs = lhs->unwrap_any_unmergeable ();
+  rhs = rhs->unwrap_any_unmergeable ();
+
+  /* Nothing can be known about unknown or poisoned values.  */
+  if (lhs->get_kind () == SK_UNKNOWN
+      || lhs->get_kind () == SK_POISONED
+      || rhs->get_kind () == SK_UNKNOWN
+      || rhs->get_kind () == SK_POISONED)
+    return tristate (tristate::TS_UNKNOWN);
+
+  if (lhs == rhs
+      && !(FLOAT_TYPE_P (lhs->get_type ())
+	   || FLOAT_TYPE_P (rhs->get_type ())))
+    {
+      switch (op)
+	{
+	case EQ_EXPR:
+	case GE_EXPR:
+	case LE_EXPR:
+	  return tristate (tristate::TS_TRUE);
+
+	case NE_EXPR:
+	case GT_EXPR:
+	case LT_EXPR:
+	  return tristate (tristate::TS_FALSE);
+	default:
+	  break;
+	}
+    }
+
+  equiv_class_id lhs_ec (-1);
+  equiv_class_id rhs_ec (-1);
+  get_equiv_class_by_svalue (lhs, &lhs_ec);
+  get_equiv_class_by_svalue (rhs, &rhs_ec);
+  if (!lhs_ec.null_p () && !rhs_ec.null_p ())
+    {
+      tristate result_for_ecs
+	= eval_condition (lhs_ec, op, rhs_ec);
+      if (result_for_ecs.is_known ())
+	return result_for_ecs;
+    }
+
+  /* If at least one is not in an EC, we have no constraints
+     comparing LHS and RHS yet.
+     They might still be comparable if one (or both) is a constant.
+
+     Alternatively, we can also get here if we had ECs but they weren't
+     comparable.  Again, constant comparisons might give an answer.  */
+  tree lhs_const = lhs->maybe_get_constant ();
+  tree rhs_const = rhs->maybe_get_constant ();
+  if (lhs_const && rhs_const)
+    {
+      tristate result_for_constants
+	= compare_constants (lhs_const, op, rhs_const);
+      if (result_for_constants.is_known ())
+	return result_for_constants;
+    }
+
+  if (!lhs_ec.null_p ())
+    {
+      if (rhs_const)
+	return eval_condition (lhs_ec, op, rhs_const);
+    }
+  if (!rhs_ec.null_p ())
+    {
+      if (lhs_const)
+	{
+	  enum tree_code swapped_op = swap_tree_comparison (op);
+	  return eval_condition (rhs_ec, swapped_op, lhs_const);
+	}
+    }
+
+  return tristate (tristate::TS_UNKNOWN);
+}
+
+/* Delete any information about svalues identified by P.
    Such instances are removed from equivalence classes, and any
    redundant ECs and constraints are also removed.
    Accumulate stats into STATS.  */
 
+template <typename PurgeCriteria>
 void
-constraint_manager::purge (const purge_criteria &p, purge_stats *stats)
+constraint_manager::purge (const PurgeCriteria &p, purge_stats *stats)
 {
-  /* Delete any svalue_ids identified by P within the various equivalence
+  /* Delete any svalues identified by P within the various equivalence
      classes.  */
   for (unsigned ec_idx = 0; ec_idx < m_equiv_classes.length (); )
     {
       equiv_class *ec = m_equiv_classes[ec_idx];
 
       int i;
-      svalue_id *pv;
+      const svalue *sval;
       bool delete_ec = false;
-      FOR_EACH_VEC_ELT (ec->m_vars, i, pv)
+      FOR_EACH_VEC_ELT (ec->m_vars, i, sval)
 	{
-	  if (*pv == ec->m_cst_sid)
+	  if (sval == ec->m_cst_sval)
 	    continue;
-	  if (p.should_purge_p (*pv))
+	  if (p.should_purge_p (sval))
 	    {
-	      if (ec->del (*pv))
+	      if (ec->del (sval))
 		if (!ec->m_constant)
 		  delete_ec = true;
 	    }
@@ -1190,20 +1596,43 @@ constraint_manager::purge (const purge_criteria &p, purge_stats *stats)
   validate ();
 }
 
-/* Remap all svalue_ids within this constraint_manager using MAP.  */
+/* Implementation of PurgeCriteria: purge svalues that are not live
+   with respect to LIVE_SVALUES and MODEL.  */
+
+class dead_svalue_purger
+{
+public:
+  dead_svalue_purger (const svalue_set &live_svalues,
+		      const region_model *model)
+  : m_live_svalues (live_svalues), m_model (model)
+  {
+  }
+
+  bool should_purge_p (const svalue *sval) const
+  {
+    return !sval->live_p (m_live_svalues, m_model);
+  }
+
+private:
+  const svalue_set &m_live_svalues;
+  const region_model *m_model;
+};
+
+/* Purge dead svalues from equivalence classes and update constraints
+   accordingly.  */
 
 void
-constraint_manager::remap_svalue_ids (const svalue_id_map &map)
+constraint_manager::
+on_liveness_change (const svalue_set &live_svalues,
+		    const region_model *model)
 {
-  int i;
-  equiv_class *ec;
-  FOR_EACH_VEC_ELT (m_equiv_classes, i, ec)
-    ec->remap_svalue_ids (map);
+  dead_svalue_purger p (live_svalues, model);
+  purge (p, NULL);
 }
 
 /* Comparator for use by constraint_manager::canonicalize.
    Sort a pair of equiv_class instances, using the representative
-   svalue_id as a sort key.  */
+   svalue as a sort key.  */
 
 static int
 equiv_class_cmp (const void *p1, const void *p2)
@@ -1211,10 +1640,17 @@ equiv_class_cmp (const void *p1, const void *p2)
   const equiv_class *ec1 = *(const equiv_class * const *)p1;
   const equiv_class *ec2 = *(const equiv_class * const *)p2;
 
-  svalue_id rep1 = ec1->get_representative ();
-  svalue_id rep2 = ec2->get_representative ();
+  const svalue *rep1 = ec1->get_representative ();
+  const svalue *rep2 = ec2->get_representative ();
+
+  gcc_assert (rep1);
+  gcc_assert (rep2);
 
-  return rep1.as_int () - rep2.as_int ();
+  if (rep1 < rep2)
+    return 1;
+  if (rep1 > rep2)
+    return -1;
+  return 0;
 }
 
 /* Comparator for use by constraint_manager::canonicalize.
@@ -1234,48 +1670,79 @@ constraint_cmp (const void *p1, const void *p2)
   return c1->m_op - c2->m_op;
 }
 
-/* Reorder the equivalence classes and constraints within this
-   constraint_manager into a canonical order, to increase the
+/* Purge redundant equivalence classes and constraints, and reorder them
+   within this constraint_manager into a canonical order, to increase the
    chances of finding equality with another instance.  */
 
 void
-constraint_manager::canonicalize (unsigned num_svalue_ids)
+constraint_manager::canonicalize ()
 {
-  /* First, sort svalue_ids within the ECs.  */
+  /* First, sort svalues within the ECs.  */
   unsigned i;
   equiv_class *ec;
   FOR_EACH_VEC_ELT (m_equiv_classes, i, ec)
     ec->canonicalize ();
 
-  /* Next, sort the ECs into a canonical order.  */
+  /* TODO: remove constraints where both sides have a constant, and are
+     thus implicit.  But does this break transitivity?  */
 
-  /* We will need to remap the equiv_class_ids in the constraints,
+  /* We will be purging and reordering ECs.
+     We will need to remap the equiv_class_ids in the constraints,
      so we need to store the original index of each EC.
-     Build a lookup table, mapping from representative svalue_id
-     to the original equiv_class_id of that svalue_id.  */
-  auto_vec<equiv_class_id> original_ec_id (num_svalue_ids);
-  for (i = 0; i < num_svalue_ids; i++)
-    original_ec_id.quick_push (equiv_class_id::null ());
+     Build a lookup table, mapping from the representative svalue
+     to the original equiv_class_id of that svalue.  */
+  hash_map<const svalue *, equiv_class_id> original_ec_id;
+  const unsigned orig_num_equiv_classes = m_equiv_classes.length ();
   FOR_EACH_VEC_ELT (m_equiv_classes, i, ec)
     {
-      svalue_id rep = ec->get_representative ();
-      gcc_assert (!rep.null_p ());
-      original_ec_id[rep.as_int ()] = i;
+      const svalue *rep = ec->get_representative ();
+      gcc_assert (rep);
+      original_ec_id.put (rep, i);
     }
 
-  /* Sort the equivalence classes.  */
+  /* Find ECs used by constraints.  */
+  hash_set<const equiv_class *> used_ecs;
+  constraint *c;
+  FOR_EACH_VEC_ELT (m_constraints, i, c)
+    {
+      used_ecs.add (m_equiv_classes[c->m_lhs.as_int ()]);
+      used_ecs.add (m_equiv_classes[c->m_rhs.as_int ()]);
+    }
+
+  /* Purge unused ECs: those that aren't used by constraints and
+     that effectively have only one svalue (either in m_constant
+     or in m_vars).  */
+  {
+    /* "unordered remove if" from a vec.  */
+    unsigned i = 0;
+    while (i < m_equiv_classes.length ())
+      {
+	equiv_class *ec = m_equiv_classes[i];
+	if (!used_ecs.contains (ec)
+	    && ((ec->m_vars.length () < 2 && ec->m_constant == NULL_TREE)
+		|| (ec->m_vars.length () == 0)))
+	  {
+	    m_equiv_classes.unordered_remove (i);
+	    delete ec;
+	  }
+	else
+	  i++;
+      }
+  }
+
+  /* Next, sort the surviving ECs into a canonical order.  */
   m_equiv_classes.qsort (equiv_class_cmp);
 
   /* Populate ec_id_map based on the old vs new EC ids.  */
-  one_way_id_map<equiv_class_id> ec_id_map (m_equiv_classes.length ());
+  one_way_id_map<equiv_class_id> ec_id_map (orig_num_equiv_classes);
   FOR_EACH_VEC_ELT (m_equiv_classes, i, ec)
     {
-      svalue_id rep = ec->get_representative ();
-      ec_id_map.put (original_ec_id[rep.as_int ()], i);
+      const svalue *rep = ec->get_representative ();
+      gcc_assert (rep);
+      ec_id_map.put (*original_ec_id.get (rep), i);
     }
 
-  /* Update the EC ids within the constraints.  */
-  constraint *c;
+  /* Use ec_id_map to update the EC ids within the constraints.  */
   FOR_EACH_VEC_ELT (m_constraints, i, c)
     {
       ec_id_map.update (&c->m_lhs);
@@ -1286,37 +1753,6 @@ constraint_manager::canonicalize (unsigned num_svalue_ids)
   m_constraints.qsort (constraint_cmp);
 }
 
-/* A concrete subclass of constraint_manager for use when
-   merging two constraint_manager into a third constraint_manager,
-   each of which has its own region_model.
-   Calls are delegated to the constraint_manager for the merged model,
-   and thus affect its region_model.  */
-
-class cleaned_constraint_manager : public constraint_manager
-{
-public:
-  cleaned_constraint_manager (constraint_manager *merged) : m_merged (merged) {}
-
-  constraint_manager *clone (region_model *) const FINAL OVERRIDE
-  {
-    gcc_unreachable ();
-  }
-  tree maybe_get_constant (svalue_id sid) const FINAL OVERRIDE
-  {
-    return m_merged->maybe_get_constant (sid);
-  }
-  svalue_id get_sid_for_constant (tree cst) const FINAL OVERRIDE
-  {
-    return m_merged->get_sid_for_constant (cst);
-  }
-  virtual int get_num_svalues () const FINAL OVERRIDE
-  {
-    return m_merged->get_num_svalues ();
-  }
-private:
-  constraint_manager *m_merged;
-};
-
 /* Concrete subclass of fact_visitor for use by constraint_manager::merge.
    For every fact in CM_A, see if it is also true in *CM_B.  Add such
    facts to *OUT.  */
@@ -1324,14 +1760,25 @@ private:
 class merger_fact_visitor : public fact_visitor
 {
 public:
-  merger_fact_visitor (constraint_manager *cm_b,
-		       constraint_manager *out)
-  : m_cm_b (cm_b), m_out (out)
+  merger_fact_visitor (const constraint_manager *cm_b,
+		       constraint_manager *out,
+		       const model_merger &merger)
+  : m_cm_b (cm_b), m_out (out), m_merger (merger)
   {}
 
-  void on_fact (svalue_id lhs, enum tree_code code, svalue_id rhs)
+  void on_fact (const svalue *lhs, enum tree_code code, const svalue *rhs)
     FINAL OVERRIDE
   {
+    /* Special-case for widening.  */
+    if (lhs->get_kind () == SK_WIDENING)
+      if (!m_cm_b->get_equiv_class_by_svalue (lhs, NULL))
+	{
+	  /* LHS isn't constrained within m_cm_b.  */
+	  bool sat = m_out->add_constraint (lhs, code, rhs);
+	  gcc_assert (sat);
+	  return;
+	}
+
     if (m_cm_b->eval_condition (lhs, code, rhs).is_true ())
       {
 	bool sat = m_out->add_constraint (lhs, code, rhs);
@@ -1340,8 +1787,9 @@ public:
   }
 
 private:
-  constraint_manager *m_cm_b;
+  const constraint_manager *m_cm_b;
   constraint_manager *m_out;
+  const model_merger &m_merger;
 };
 
 /* Use MERGER to merge CM_A and CM_B into *OUT.
@@ -1356,90 +1804,12 @@ constraint_manager::merge (const constraint_manager &cm_a,
 			   constraint_manager *out,
 			   const model_merger &merger)
 {
-  gcc_assert (merger.m_sid_mapping);
-
-  /* Map svalue_ids in each equiv class from both sources
-     to the merged region_model, dropping ids that don't survive merger,
-     and potentially creating svalues in *OUT for constants.  */
-  cleaned_constraint_manager cleaned_cm_a (out);
-  const one_way_svalue_id_map &map_a_to_m
-    = merger.m_sid_mapping->m_map_from_a_to_m;
-  clean_merger_input (cm_a, map_a_to_m, &cleaned_cm_a);
-
-  cleaned_constraint_manager cleaned_cm_b (out);
-  const one_way_svalue_id_map &map_b_to_m
-    = merger.m_sid_mapping->m_map_from_b_to_m;
-  clean_merger_input (cm_b, map_b_to_m, &cleaned_cm_b);
-
-  /* At this point, the two cleaned CMs have ECs and constraints referring
-     to svalues in the merged region model, but both of them have separate
-     ECs.  */
-
   /* Merge the equivalence classes and constraints.
      The easiest way to do this seems to be to enumerate all of the facts
-     in cleaned_cm_a, see which are also true in cleaned_cm_b,
+     in cm_a, see which are also true in cm_b,
      and add those to *OUT.  */
-  merger_fact_visitor v (&cleaned_cm_b, out);
-  cleaned_cm_a.for_each_fact (&v);
-}
-
-/* A subroutine of constraint_manager::merge.
-   Use MAP_SID_TO_M to map equivalence classes and constraints from
-   SM_IN to *OUT.  Purge any non-constant svalue_id that don't appear
-   in the result of MAP_SID_TO_M, purging any ECs and their constraints
-   that become empty as a result.  Potentially create svalues in
-   the merged region_model for constants that weren't already in use there.  */
-
-void
-constraint_manager::
-clean_merger_input (const constraint_manager &cm_in,
-		    const one_way_svalue_id_map &map_sid_to_m,
-		    constraint_manager *out)
-{
-  one_way_id_map<equiv_class_id> map_ec_to_m
-    (cm_in.m_equiv_classes.length ());
-  unsigned ec_idx;
-  equiv_class *ec;
-  FOR_EACH_VEC_ELT (cm_in.m_equiv_classes, ec_idx, ec)
-    {
-      equiv_class cleaned_ec;
-      if (tree cst = ec->get_any_constant ())
-	{
-	  cleaned_ec.m_constant = cst;
-	  /* Lazily create the constant in the out region_model.  */
-	  cleaned_ec.m_cst_sid = out->get_sid_for_constant (cst);
-	}
-      unsigned var_idx;
-      svalue_id *var_in_sid;
-      FOR_EACH_VEC_ELT (ec->m_vars, var_idx, var_in_sid)
-	{
-	  svalue_id var_m_sid = map_sid_to_m.get_dst_for_src (*var_in_sid);
-	  if (!var_m_sid.null_p ())
-	    cleaned_ec.m_vars.safe_push (var_m_sid);
-	}
-      if (cleaned_ec.get_any_constant () || !cleaned_ec.m_vars.is_empty ())
-	{
-	  map_ec_to_m.put (ec_idx, out->m_equiv_classes.length ());
-	  out->m_equiv_classes.safe_push (new equiv_class (cleaned_ec));
-	}
-    }
-
-  /* Write out to *OUT any constraints for which both sides survived
-     cleaning, using the new EC IDs.  */
-  unsigned con_idx;
-  constraint *c;
-  FOR_EACH_VEC_ELT (cm_in.m_constraints, con_idx, c)
-    {
-      equiv_class_id new_lhs = map_ec_to_m.get_dst_for_src (c->m_lhs);
-      if (new_lhs.null_p ())
-	continue;
-      equiv_class_id new_rhs = map_ec_to_m.get_dst_for_src (c->m_rhs);
-      if (new_rhs.null_p ())
-	continue;
-      out->m_constraints.safe_push (constraint (new_lhs,
-						c->m_op,
-						new_rhs));
-    }
+  merger_fact_visitor v (&cm_b, out, merger);
+  cm_a.for_each_fact (&v);
 }
 
 /* Call VISITOR's on_fact vfunc repeatedly to express the various
@@ -1455,12 +1825,12 @@ constraint_manager::for_each_fact (fact_visitor *visitor) const
   equiv_class *ec;
   FOR_EACH_VEC_ELT (m_equiv_classes, ec_idx, ec)
     {
-      if (!ec->m_cst_sid.null_p ())
+      if (ec->m_cst_sval)
 	{
 	  unsigned i;
-	  svalue_id *sid;
-	  FOR_EACH_VEC_ELT (ec->m_vars, i, sid)
-	    visitor->on_fact (ec->m_cst_sid, EQ_EXPR, *sid);
+	  const svalue *sval;
+	  FOR_EACH_VEC_ELT (ec->m_vars, i, sval)
+	    visitor->on_fact (ec->m_cst_sval, EQ_EXPR, sval);
 	}
       for (unsigned i = 0; i < ec->m_vars.length (); i++)
 	for (unsigned j = i + 1; j < ec->m_vars.length (); j++)
@@ -1476,17 +1846,17 @@ constraint_manager::for_each_fact (fact_visitor *visitor) const
       const equiv_class &ec_rhs = c->m_rhs.get_obj (*this);
       enum tree_code code = constraint_tree_code (c->m_op);
 
-      if (!ec_lhs.m_cst_sid.null_p ())
+      if (ec_lhs.m_cst_sval)
 	{
 	  for (unsigned j = 0; j < ec_rhs.m_vars.length (); j++)
 	    {
-	      visitor->on_fact (ec_lhs.m_cst_sid, code, ec_rhs.m_vars[j]);
+	      visitor->on_fact (ec_lhs.m_cst_sval, code, ec_rhs.m_vars[j]);
 	    }
 	}
       for (unsigned i = 0; i < ec_lhs.m_vars.length (); i++)
 	{
-	  if (!ec_rhs.m_cst_sid.null_p ())
-	    visitor->on_fact (ec_lhs.m_vars[i], code, ec_rhs.m_cst_sid);
+	  if (ec_rhs.m_cst_sval)
+	    visitor->on_fact (ec_lhs.m_vars[i], code, ec_rhs.m_cst_sval);
 	  for (unsigned j = 0; j < ec_rhs.m_vars.length (); j++)
 	    visitor->on_fact (ec_lhs.m_vars[i], code, ec_rhs.m_vars[j]);
 	}
@@ -1510,17 +1880,13 @@ constraint_manager::validate () const
       gcc_assert (ec);
 
       int j;
-      svalue_id *sid;
-      FOR_EACH_VEC_ELT (ec->m_vars, j, sid)
-	{
-	  gcc_assert (!sid->null_p ());
-	  gcc_assert (sid->as_int () < get_num_svalues ());
-	}
+      const svalue *sval;
+      FOR_EACH_VEC_ELT (ec->m_vars, j, sval)
+	gcc_assert (sval);
       if (ec->m_constant)
 	{
 	  gcc_assert (CONSTANT_CLASS_P (ec->m_constant));
-	  gcc_assert (!ec->m_cst_sid.null_p ());
-	  gcc_assert (ec->m_cst_sid.as_int () < get_num_svalues ());
+	  gcc_assert (ec->m_cst_sval);
 	}
 #if 0
       else
@@ -1544,8 +1910,7 @@ namespace selftest {
 
 /* Various constraint_manager selftests.
    These have to be written in terms of a region_model, since
-   the latter is responsible for managing svalue and svalue_id
-   instances.  */
+   the latter is responsible for managing svalue instances.  */
 
 /* Verify that setting and getting simple conditions within a region_model
    work (thus exercising the underlying constraint_manager).  */
@@ -1562,7 +1927,8 @@ test_constraint_conditions ()
 
   /* Self-comparisons.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ASSERT_CONDITION_TRUE (model, x, EQ_EXPR, x);
     ASSERT_CONDITION_TRUE (model, x, LE_EXPR, x);
     ASSERT_CONDITION_TRUE (model, x, GE_EXPR, x);
@@ -1571,9 +1937,25 @@ test_constraint_conditions ()
     ASSERT_CONDITION_FALSE (model, x, GT_EXPR, x);
   }
 
+  /* Adding self-equality shouldn't add equiv classes.  */
+  {
+    region_model_manager mgr;
+    region_model model (&mgr);
+    ADD_SAT_CONSTRAINT (model, x, EQ_EXPR, x);
+    ADD_SAT_CONSTRAINT (model, int_42, EQ_EXPR, int_42);
+    /* ...even when done directly via svalues: */
+    const svalue *sval_int_42 = model.get_rvalue (int_42, NULL);
+    bool sat = model.get_constraints ()->add_constraint (sval_int_42,
+							  EQ_EXPR,
+							  sval_int_42);
+    ASSERT_TRUE (sat);
+    ASSERT_EQ (model.get_constraints ()->m_equiv_classes.length (), 0);
+  }
+
   /* x == y.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ASSERT_CONDITION_UNKNOWN (model, x, EQ_EXPR, y);
 
     ADD_SAT_CONSTRAINT (model, x, EQ_EXPR, y);
@@ -1604,7 +1986,8 @@ test_constraint_conditions ()
 
   /* x == y, then y == z  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ASSERT_CONDITION_UNKNOWN (model, x, EQ_EXPR, y);
 
     ADD_SAT_CONSTRAINT (model, x, EQ_EXPR, y);
@@ -1620,7 +2003,8 @@ test_constraint_conditions ()
 
   /* x != y.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
 
     ADD_SAT_CONSTRAINT (model, x, NE_EXPR, y);
 
@@ -1650,7 +2034,8 @@ test_constraint_conditions ()
 
   /* x < y.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
 
     ADD_SAT_CONSTRAINT (model, x, LT_EXPR, y);
 
@@ -1672,7 +2057,8 @@ test_constraint_conditions ()
 
   /* x <= y.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
 
     ADD_SAT_CONSTRAINT (model, x, LE_EXPR, y);
 
@@ -1694,7 +2080,8 @@ test_constraint_conditions ()
 
   /* x > y.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
 
     ADD_SAT_CONSTRAINT (model, x, GT_EXPR, y);
 
@@ -1716,7 +2103,8 @@ test_constraint_conditions ()
 
   /* x >= y.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
 
     ADD_SAT_CONSTRAINT (model, x, GE_EXPR, y);
 
@@ -1740,7 +2128,8 @@ test_constraint_conditions ()
 
   /* Constants.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ASSERT_CONDITION_FALSE (model, int_0, EQ_EXPR, int_42);
     ASSERT_CONDITION_TRUE (model, int_0, NE_EXPR, int_42);
     ASSERT_CONDITION_TRUE (model, int_0, LT_EXPR, int_42);
@@ -1751,7 +2140,8 @@ test_constraint_conditions ()
 
   /* x == 0, y == 42.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, x, EQ_EXPR, int_0);
     ADD_SAT_CONSTRAINT (model, y, EQ_EXPR, int_42);
 
@@ -1767,42 +2157,48 @@ test_constraint_conditions ()
 
   /* x == y && x != y.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, x, EQ_EXPR, y);
     ADD_UNSAT_CONSTRAINT (model, x, NE_EXPR, y);
   }
 
   /* x == 0 then x == 42.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, x, EQ_EXPR, int_0);
     ADD_UNSAT_CONSTRAINT (model, x, EQ_EXPR, int_42);
   }
 
   /* x == 0 then x != 0.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, x, EQ_EXPR, int_0);
     ADD_UNSAT_CONSTRAINT (model, x, NE_EXPR, int_0);
   }
 
   /* x == 0 then x > 0.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, x, EQ_EXPR, int_0);
     ADD_UNSAT_CONSTRAINT (model, x, GT_EXPR, int_0);
   }
 
   /* x != y && x == y.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, x, NE_EXPR, y);
     ADD_UNSAT_CONSTRAINT (model, x, EQ_EXPR, y);
   }
 
   /* x <= y && x > y.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, x, LE_EXPR, y);
     ADD_UNSAT_CONSTRAINT (model, x, GT_EXPR, y);
   }
@@ -1822,7 +2218,8 @@ test_transitivity ()
 
   /* a == b, then c == d, then c == b.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ASSERT_CONDITION_UNKNOWN (model, a, EQ_EXPR, b);
     ASSERT_CONDITION_UNKNOWN (model, b, EQ_EXPR, c);
     ASSERT_CONDITION_UNKNOWN (model, c, EQ_EXPR, d);
@@ -1842,7 +2239,8 @@ test_transitivity ()
 
   /* Transitivity: "a < b", "b < c" should imply "a < c".  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, LT_EXPR, b);
     ADD_SAT_CONSTRAINT (model, b, LT_EXPR, c);
 
@@ -1852,7 +2250,8 @@ test_transitivity ()
 
   /* Transitivity: "a <= b", "b < c" should imply "a < c".  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, LE_EXPR, b);
     ADD_SAT_CONSTRAINT (model, b, LT_EXPR, c);
 
@@ -1862,7 +2261,8 @@ test_transitivity ()
 
   /* Transitivity: "a <= b", "b <= c" should imply "a <= c".  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, LE_EXPR, b);
     ADD_SAT_CONSTRAINT (model, b, LE_EXPR, c);
 
@@ -1872,7 +2272,8 @@ test_transitivity ()
 
   /* Transitivity: "a > b", "b > c" should imply "a > c".  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, GT_EXPR, b);
     ADD_SAT_CONSTRAINT (model, b, GT_EXPR, c);
 
@@ -1882,7 +2283,8 @@ test_transitivity ()
 
   /* Transitivity: "a >= b", "b > c" should imply " a > c".  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, GE_EXPR, b);
     ADD_SAT_CONSTRAINT (model, b, GT_EXPR, c);
 
@@ -1892,7 +2294,8 @@ test_transitivity ()
 
   /* Transitivity: "a >= b", "b >= c" should imply "a >= c".  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, GE_EXPR, b);
     ADD_SAT_CONSTRAINT (model, b, GE_EXPR, c);
 
@@ -1907,7 +2310,8 @@ test_transitivity ()
      but also that:
        (a < d).  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, LT_EXPR, b);
     ADD_SAT_CONSTRAINT (model, c, LT_EXPR, d);
     ADD_SAT_CONSTRAINT (model, b, LT_EXPR, c);
@@ -1919,17 +2323,23 @@ test_transitivity ()
 
   /* Transitivity: "a >= b", "b >= a" should imply that a == b.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, GE_EXPR, b);
     ADD_SAT_CONSTRAINT (model, b, GE_EXPR, a);
 
     // TODO:
     ASSERT_CONDITION_TRUE (model, a, EQ_EXPR, b);
+
+    /* The ECs for a and b should have merged, and any constraints removed.  */
+    ASSERT_EQ (model.get_constraints ()->m_equiv_classes.length (), 1);
+    ASSERT_EQ (model.get_constraints ()->m_constraints.length (), 0);
   }
 
   /* Transitivity: "a >= b", "b > a" should be impossible.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, GE_EXPR, b);
     ADD_UNSAT_CONSTRAINT (model, b, GT_EXPR, a);
   }
@@ -1937,7 +2347,8 @@ test_transitivity ()
   /* Transitivity: "a >= b", "b >= c", "c >= a" should imply
      that a == b == c.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, GE_EXPR, b);
     ADD_SAT_CONSTRAINT (model, b, GE_EXPR, c);
     ADD_SAT_CONSTRAINT (model, c, GE_EXPR, a);
@@ -1948,7 +2359,8 @@ test_transitivity ()
   /* Transitivity: "a > b", "b > c", "c > a"
      should be impossible.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, GT_EXPR, b);
     ADD_SAT_CONSTRAINT (model, b, GT_EXPR, c);
     ADD_UNSAT_CONSTRAINT (model, c, GT_EXPR, a);
@@ -1974,14 +2386,16 @@ test_constant_comparisons ()
 
   /* Given a >= 1024, then a <= 1023 should be impossible.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, GE_EXPR, int_1024);
     ADD_UNSAT_CONSTRAINT (model, a, LE_EXPR, int_1023);
   }
 
   /* a > 4.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, GT_EXPR, int_4);
     ASSERT_CONDITION_TRUE (model, a, GT_EXPR, int_4);
     ASSERT_CONDITION_TRUE (model, a, NE_EXPR, int_3);
@@ -1990,7 +2404,8 @@ test_constant_comparisons ()
 
   /* a <= 4.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, LE_EXPR, int_4);
     ASSERT_CONDITION_FALSE (model, a, GT_EXPR, int_4);
     ASSERT_CONDITION_FALSE (model, a, GT_EXPR, int_5);
@@ -1999,7 +2414,8 @@ test_constant_comparisons ()
 
   /* If "a > b" and "a == 3", then "b == 4" ought to be unsatisfiable.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, a, GT_EXPR, b);
     ADD_SAT_CONSTRAINT (model, a, EQ_EXPR, int_3);
     ADD_UNSAT_CONSTRAINT (model, b, EQ_EXPR, int_4);
